// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Globalization;
using Hiperscan.ApoIdentCore.Misc;
using Hiperscan.ApoIdentCore.SectionManager.FieldDefinitions;
using Hiperscan.Unix;

namespace Hiperscan.ApoIdentCore.SectionManager.Specimen.Fields
{
    public class ExpiryDateField : InputField<string>
    {
        public ExpiryDateField()
        {
            this.Init();
        }

        public override void SetDefaultValue()
        {
            this.Entry = String.Empty;
            this.DateTimeValue = I18nDateFormat.EmptyDate;
        }

        protected override bool CheckEntry()
        {
            if (DateTime.TryParseExact(this.entry, this.ParseDateFormat, CultureInfo.CurrentCulture, System.Globalization.DateTimeStyles.None, out DateTime date))
            {
                this.DateTimeValue = date;
                return true;
            }

            else
            {
                this.DateTimeValue = I18nDateFormat.EmptyDate;
                return false;
            }
        }

        protected override bool Compare(string value1, string value2)
        {
            return value1 == value2;
        }

        public override string GetEntryValue()
        {
            return this.entry;
        }

        public DateTime DateTimeValue { get; private set; }

        public override string ErrorMessage => String.Format(Catalog.GetString("This field is a mandatory field and must have the following format: {0}."), I18nDateFormat.AdviceDateFormat);
        public override int FieldLength => I18nDateFormat.AdviceDateFormat.Length;
        public string ParseDateFormat => I18nDateFormat.ParseDateFormat;
    }
}
